-- CONSTANTS

local ADDON_NAME = "ChangeSpec"

local COMMAND_NAME = "cs"

local COMMAND_NAME2 = "changespec"

local DATABASE_NAME = ADDON_NAME .. "DB"

local DATABASE_DEFAULTS = {
  char = {
    minimap = { hide = false }
  }
}
local function LocalAction()

  local i = GetActiveTalentGroup()
   SetActiveTalentGroup(i==1 and 2 or 1)  
end


----- CLASS - ChangeSpec

local ChangeSpec = LibStub("AceAddon-3.0"):NewAddon(ADDON_NAME, "AceConsole-3.0", "AceEvent-3.0")


function ChangeSpec:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New(DATABASE_NAME, DATABASE_DEFAULTS)


  myself = self

  self.cdb = LibStub("LibDataBroker-1.1"):NewDataObject(ADDON_NAME, {
      type = "data source",
      icon = "Interface\\Icons\\Ability_rogue_shadowstrikes",
      text = ADDON_NAME,
      OnClick = function(self, button)
        if (button == "LeftButton" and IsShiftKeyDown()) then
          myself:StartLog()
        elseif (button == "LeftButton") then
          myself:CSAction()
        elseif (button == "RightButton" and IsShiftKeyDown()) then
          myself:Reload()
        elseif (button == "RightButton") then
          myself:IconShow("show")
        end          
      end,
      OnTooltipShow = function(tooltip)
    
        if not tooltip or not tooltip.AddLine then return end
      
        tooltip:AddLine("|cF29B6F6EChange your Spec")
        tooltip:AddLine("|cF117A65ELeft-Click|r " .. "Change Spec");
        tooltip:AddLine("|cF117A65ERight-Click|r " .. "Hide Icon");
        tooltip:AddLine("|cF117A65EShift Left-Click|r " .. "Combatlog Enable");
        tooltip:AddLine("|cF117A65EShift Right-Click|r " .. "ReloadUI");
      
      end
    })
    
  self.dbicon = LibStub("LibDBIcon-1.0")
  self.dbicon:Register(ADDON_NAME, self.cdb, self.db.char.minimap)

  self:RegisterChatCommand(COMMAND_NAME, "OnChatCommand")

  self:RegisterChatCommand(COMMAND_NAME2, "OnChatCommand")


end


function ChangeSpec:CSAction(number)
  if not number or number:trim() == "" then  
    local i = GetActiveTalentGroup()
    SetActiveTalentGroup(i==1 and 2 or 1)  
  else
    if (string.len(number) > 0 ) then
      SetActiveTalentGroup(number)
      --MurlocScream()
    else
      local i = GetActiveTalentGroup()
      SetActiveTalentGroup(i==1 and 2 or 1)    
      --MurlocScream()
    end
  end
end



function ChangeSpec:StartLog()
  LoggingCombat(true);
  print("|cfAED5810".. "CombatLog ENABLE" .."|r")
  --print("|cffffff00".. L["Combatlog enabled"] .."|r");
  SetCVar("advancedCombatLogging", 1);
end

function ChangeSpec:IconShow()
  self.db.char.minimap.hide = not self.db.char.minimap.hide
  if self.db.char.minimap.hide then 
    self.dbicon:Hide(ADDON_NAME)
  else 
    self.dbicon:Show(ADDON_NAME)
  end
end

function ChangeSpec:OnChatCommand(str)

  if not str or str:trim() == "show" then
    self:IconShow()
  else 
    self:CSAction(str)
  end
end

function ChangeSpec:Reload()
  ReloadUI()
end

function ChangeSpec:OnEnable()
  
-- self.cdb.OnClick = function() self:OnCdbClick(self, button) end
--self.ldb.OnEnter = function(anchor) self:OnLdbEnter(anchor) end
--self.ldb.OnLeave = function() self:OnLdbLeave() end
  

end


